Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/ChangeNodeTypeManipulation.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/ChangeNodeTypeManipulation.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/ChangeNodeTypeManipulation.cs	(revision 2210)
@@ -30,7 +30,8 @@
 using HeuristicLab.Constraints;
 using System.Diagnostics;
+using HeuristicLab.GP.Interfaces;
 
 namespace HeuristicLab.GP {
-  public class ChangeNodeTypeManipulation : OperatorBase {
+  public class ChangeNodeTypeManipulation : GPManipulatorBase {
 
     public override string Description {
@@ -44,29 +45,14 @@
     public ChangeNodeTypeManipulation()
       : base() {
-      AddVariableInfo(new VariableInfo("Random", "Uniform random number generator", typeof(MersenneTwister), VariableKind.In));
-      AddVariableInfo(new VariableInfo("OperatorLibrary", "The operator library containing all available operators", typeof(FunctionLibrary), VariableKind.In));
-      AddVariableInfo(new VariableInfo("MaxTreeHeight", "The maximal allowed height of the tree", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("MaxTreeSize", "The maximal allowed size (number of nodes) of the tree", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("FunctionTree", "The tree to mutate", typeof(IFunctionTree), VariableKind.In | VariableKind.Out));
-      AddVariableInfo(new VariableInfo("TreeSize", "The size (number of nodes) of the tree", typeof(IntData), VariableKind.In | VariableKind.Out));
-      AddVariableInfo(new VariableInfo("TreeHeight", "The height of the tree", typeof(IntData), VariableKind.In | VariableKind.Out));
     }
 
-
-    public override IOperation Apply(IScope scope) {
-      IFunctionTree root = GetVariableValue<IFunctionTree>("FunctionTree", scope, false);
-      MersenneTwister random = GetVariableValue<MersenneTwister>("Random", scope, true);
-      FunctionLibrary library = GetVariableValue<FunctionLibrary>("OperatorLibrary", scope, true);
-      IntData treeSize = GetVariableValue<IntData>("TreeSize", scope, false);
-      IntData treeHeight = GetVariableValue<IntData>("TreeHeight", scope, false);
-      int maxTreeSize = GetVariableValue<IntData>("MaxTreeSize", scope, true).Data;
-      int maxTreeHeight = GetVariableValue<IntData>("MaxTreeHeight", scope, true).Data;
+    internal override IOperation Manipulate(MersenneTwister random, IGeneticProgrammingModel gpModel, FunctionLibrary library, int maxTreeSize, int maxTreeHeight, IScope scope) {
       TreeGardener gardener = new TreeGardener(random, library);
-      IFunctionTree parent = gardener.GetRandomParentNode(root);
+      IFunctionTree parent = gardener.GetRandomParentNode(gpModel.FunctionTree);
       IFunctionTree selectedChild;
       int selectedChildIndex;
-      if(parent == null) {
+      if (parent == null) {
         selectedChildIndex = 0;
-        selectedChild = root;
+        selectedChild = gpModel.FunctionTree;
       } else {
         selectedChildIndex = random.Next(parent.SubTrees.Count);
@@ -74,10 +60,9 @@
       }
 
-      if(selectedChild.SubTrees.Count == 0) {
+      if (selectedChild.SubTrees.Count == 0) {
         IFunctionTree newTerminal = ChangeTerminalType(parent, selectedChild, selectedChildIndex, gardener, random);
-        if(parent == null) {
+        if (parent == null) {
           // no parent means the new child is the initial operator
-          // and we have to update the value in the variable
-          scope.GetVariable(scope.TranslateName("FunctionTree")).Value = newTerminal;
+          gpModel.FunctionTree = newTerminal;
         } else {
           parent.RemoveSubTree(selectedChildIndex);
@@ -85,8 +70,8 @@
           // updating the variable is not necessary because it stays the same
         }
-        Debug.Assert(gardener.IsValidTree(root));
+        Debug.Assert(gardener.IsValidTree(gpModel.FunctionTree));
         // size and height stays the same when changing a terminal so no need to update the variables
         // schedule an operation to initialize the new terminal
-        return gardener.CreateInitializationOperation(gardener.GetAllSubTrees(newTerminal), scope);
+        return TreeGardener.CreateInitializationOperation(TreeGardener.GetAllSubTrees(newTerminal), scope);
       } else {
         List<IFunctionTree> uninitializedBranches;
@@ -95,18 +80,16 @@
         // calculate the height and size difference and 
         // check if the size of the new tree is still in the allowed bounds
-        int oldChildSize = selectedChild.Size;
-        int oldChildHeight = selectedChild.Height;
-        int newChildSize = newFunctionTree.Size;
-        int newChildHeight = newFunctionTree.Height;
-        if((treeHeight.Data - oldChildHeight) + newChildHeight > maxTreeHeight ||
-          (treeSize.Data - oldChildSize) + newChildSize > maxTreeSize) {
+        int oldChildSize = selectedChild.GetSize();
+        int oldChildHeight = selectedChild.GetHeight();
+        int newChildSize = newFunctionTree.GetSize();
+        int newChildHeight = newFunctionTree.GetHeight();
+        if ((gpModel.Height - oldChildHeight) + newChildHeight > maxTreeHeight ||
+          (gpModel.Size - oldChildSize) + newChildSize > maxTreeSize) {
           // if size-constraints are violated don't change anything
           return null;
         }
-        if(parent == null) {
+        if (parent == null) {
           // no parent means the new function is the initial operator
-          // and we have to update the value in the variable
-          scope.GetVariable(scope.TranslateName("FunctionTree")).Value = newFunctionTree;
-          root = newFunctionTree;
+          gpModel.FunctionTree = newFunctionTree;
         } else {
           // remove the old child
@@ -116,13 +99,12 @@
         }
         // update size and height
-        treeSize.Data = (treeSize.Data - oldChildSize) + newChildSize;
-        treeHeight.Data = root.Height; // must recalculate height because we can't know wether the manipulated branch was the deepest branch
+        gpModel.Size = gpModel.Size - oldChildSize + newChildSize;
+        gpModel.Height = gpModel.FunctionTree.GetHeight(); // must recalculate height because we can't know wether the manipulated branch was the deepest branch
         // check if whole tree is ok
-        Debug.Assert(gardener.IsValidTree(root));
+        Debug.Assert(gardener.IsValidTree(gpModel.FunctionTree));
         // return a composite operation that initializes all created sub-trees
-        return gardener.CreateInitializationOperation(uninitializedBranches, scope);
+        return TreeGardener.CreateInitializationOperation(uninitializedBranches, scope);
       }
     }
-  
 
     private IFunctionTree ChangeTerminalType(IFunctionTree parent, IFunctionTree child, int childIndex, TreeGardener gardener, MersenneTwister random) {
@@ -133,6 +115,6 @@
         allowedTerminals = new List<IFunction>();
         var allAllowedChildren = gardener.GetAllowedSubFunctions(parent.Function, childIndex);
-        foreach(IFunction c in allAllowedChildren) {
-          if(gardener.IsTerminal(c)) allowedTerminals.Add(c);
+        foreach (IFunction c in allAllowedChildren) {
+          if (TreeGardener.IsTerminal(c)) allowedTerminals.Add(c);
         }
       }
@@ -159,5 +141,5 @@
       if (actualArity > maxArity)
         actualArity = maxArity;
-      if(actualArity < minArity)
+      if (actualArity < minArity)
         actualArity = minArity;
       // create a list that holds old sub-trees that we can reuse in the new tree
@@ -181,5 +163,5 @@
           // no existing matching tree found => create a new tree of minimal size
           IFunctionTree freshTree = gardener.CreateRandomTree(allowedSubFunctions, 1, 1);
-          freshSubTrees.AddRange(gardener.GetAllSubTrees(freshTree));
+          freshSubTrees.AddRange(TreeGardener.GetAllSubTrees(freshTree));
           newTree.InsertSubTree(i, freshTree);
         }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/CutOutNodeManipulation.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/CutOutNodeManipulation.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/CutOutNodeManipulation.cs	(revision 2210)
@@ -28,7 +28,8 @@
 using System;
 using System.Diagnostics;
+using HeuristicLab.GP.Interfaces;
 
 namespace HeuristicLab.GP {
-  public class CutOutNodeManipulation : OperatorBase {
+  public class CutOutNodeManipulation : GPManipulatorBase {
     public override string Description {
       get {
@@ -49,48 +50,29 @@
     public CutOutNodeManipulation()
       : base() {
-      AddVariableInfo(new VariableInfo("Random", "Uniform random number generator", typeof(MersenneTwister), VariableKind.In));
-      AddVariableInfo(new VariableInfo("OperatorLibrary", "The operator library containing all available operators", typeof(FunctionLibrary), VariableKind.In));
-      AddVariableInfo(new VariableInfo("MaxTreeHeight", "The maximal allowed height of the tree", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("MaxTreeSize", "The maximal allowed size (number of nodes) of the tree", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("FunctionTree", "The tree to mutate", typeof(IFunctionTree), VariableKind.In | VariableKind.Out));
-      AddVariableInfo(new VariableInfo("TreeSize", "The size (number of nodes) of the tree", typeof(IntData), VariableKind.In | VariableKind.Out));
-      AddVariableInfo(new VariableInfo("TreeHeight", "The height of the tree", typeof(IntData), VariableKind.In | VariableKind.Out));
     }
 
 
-    public override IOperation Apply(IScope scope) {
-      IFunctionTree root = GetVariableValue<IFunctionTree>("FunctionTree", scope, true);
-      MersenneTwister random = GetVariableValue<MersenneTwister>("Random", scope, true);
-      FunctionLibrary library = GetVariableValue<FunctionLibrary>("OperatorLibrary", scope, true);
-      int maxTreeHeight = GetVariableValue<IntData>("MaxTreeHeight", scope, true).Data;
-      int maxTreeSize = GetVariableValue<IntData>("MaxTreeSize", scope, true).Data;
+    internal override IOperation Manipulate(MersenneTwister random, IGeneticProgrammingModel gpModel, FunctionLibrary library, int maxTreeSize, int maxTreeHeight, IScope scope) {
       TreeGardener gardener = new TreeGardener(random, library);
-      IFunctionTree parent = gardener.GetRandomParentNode(root);
+      IFunctionTree parent = gardener.GetRandomParentNode(gpModel.FunctionTree);
       // parent == null means we should cut out the root node
       // => return a random sub-tree of the root
       if (parent == null) {
         // when there are sub-trees then replace the old tree with a random sub-tree
-        if (root.SubTrees.Count > 0) {
-          root = root.SubTrees[random.Next(root.SubTrees.Count)];
-          GetVariableValue<IntData>("TreeSize", scope, true).Data = root.Size;
-          GetVariableValue<IntData>("TreeHeight", scope, true).Data = root.Height;
-          // update the variable
-          scope.GetVariable(scope.TranslateName("FunctionTree")).Value = root;
-          Debug.Assert(gardener.IsValidTree(root));
+        if (gpModel.FunctionTree.SubTrees.Count > 0) {
+          gpModel.FunctionTree = gpModel.FunctionTree.SubTrees[random.Next(gpModel.FunctionTree.SubTrees.Count)];
+          Debug.Assert(gardener.IsValidTree(gpModel.FunctionTree));
           // we reused a sub-tree so we don't have to schedule initialization operations
           return null;
         } else {
           // we want to cut the root node and there are no sub-trees => create a new random terminal
-          IFunctionTree newTree;
-          newTree = gardener.CreateRandomTree(gardener.Terminals, 1, 1);
-          GetVariableValue<IntData>("TreeSize", scope, true).Data = newTree.Size;
-          GetVariableValue<IntData>("TreeHeight", scope, true).Data = newTree.Height;
-          // update the variable
-          scope.GetVariable(scope.TranslateName("FunctionTree")).Value = newTree;
-          Debug.Assert(gardener.IsValidTree(newTree));
+          gpModel.FunctionTree = gardener.CreateRandomTree(gardener.Terminals, 1, 1);
+          Debug.Assert(gardener.IsValidTree(gpModel.FunctionTree));
+
           // schedule an operation to initialize the whole tree
-          return gardener.CreateInitializationOperation(gardener.GetAllSubTrees(newTree), scope);
+          return TreeGardener.CreateInitializationOperation(TreeGardener.GetAllSubTrees(gpModel.FunctionTree), scope);
         }
       }
+
       // select a child to cut away
       int childIndex = random.Next(parent.SubTrees.Count);
@@ -101,11 +83,11 @@
       if (possibleChilds.Length > 0) {
         // replace child with a random child of that child
-        IFunctionTree selectedChild = possibleChilds[random.Next(possibleChilds.Length)];        
+        IFunctionTree selectedChild = possibleChilds[random.Next(possibleChilds.Length)];
         parent.RemoveSubTree(childIndex);
         parent.InsertSubTree(childIndex, selectedChild);
-        Debug.Assert(gardener.IsValidTree(root));
-        // update the size and height of our tree
-        GetVariableValue<IntData>("TreeSize", scope, true).Data = root.Size;
-        GetVariableValue<IntData>("TreeHeight", scope, true).Data = root.Height;
+        Debug.Assert(gardener.IsValidTree(gpModel.FunctionTree));
+        // recalculate the size and height of our tree
+        gpModel.Size = gpModel.FunctionTree.GetSize();
+        gpModel.Height = gpModel.FunctionTree.GetHeight();
         // don't need to schedule initialization operations
         return null;
@@ -113,17 +95,18 @@
         // can't reuse an existing branch => create a new tree
         // determine the level of the parent
-        int parentLevel = gardener.GetBranchLevel(root, parent);
+        int parentLevel = gardener.GetBranchLevel(gpModel.FunctionTree, parent);
         // first remove the old child (first step essential!)
         parent.RemoveSubTree(childIndex);
         // then determine the number of nodes left over after the child has been removed!
-        int remainingNodes = root.Size;
+        int remainingNodes = gpModel.FunctionTree.GetSize();
         allowedFunctions = gardener.GetAllowedSubFunctions(parent.Function, childIndex);
         IFunctionTree newFunctionTree = gardener.CreateRandomTree(allowedFunctions, maxTreeSize - remainingNodes, maxTreeHeight - parentLevel);
         parent.InsertSubTree(childIndex, newFunctionTree);
-        GetVariableValue<IntData>("TreeSize", scope, true).Data = root.Size;
-        GetVariableValue<IntData>("TreeHeight", scope, true).Data = root.Height;
-        Debug.Assert(gardener.IsValidTree(root));
+        Debug.Assert(gardener.IsValidTree(gpModel.FunctionTree));
+        // recalculate size and height
+        gpModel.Size = gpModel.FunctionTree.GetSize();
+        gpModel.Height = gpModel.FunctionTree.GetHeight();
         // schedule an initialization operation for the new function-tree
-        return gardener.CreateInitializationOperation(gardener.GetAllSubTrees(newFunctionTree), scope);
+        return TreeGardener.CreateInitializationOperation(TreeGardener.GetAllSubTrees(newFunctionTree), scope);
       }
     }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/DeleteSubTreeManipulation.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/DeleteSubTreeManipulation.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/DeleteSubTreeManipulation.cs	(revision 2210)
@@ -27,7 +27,8 @@
 using HeuristicLab.Random;
 using System.Diagnostics;
+using HeuristicLab.GP.Interfaces;
 
 namespace HeuristicLab.GP {
-  public class DeleteSubTreeManipulation : OperatorBase {
+  public class DeleteSubTreeManipulation : GPManipulatorBase {
     public override string Description {
       get {
@@ -39,39 +40,24 @@
     public DeleteSubTreeManipulation()
       : base() {
-      AddVariableInfo(new VariableInfo("Random", "Uniform random number generator", typeof(MersenneTwister), VariableKind.In));
-      AddVariableInfo(new VariableInfo("OperatorLibrary", "The operator library containing all available operators", typeof(FunctionLibrary), VariableKind.In));
-      AddVariableInfo(new VariableInfo("MaxTreeHeight", "The maximal allowed height of the tree", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("MaxTreeSize", "The maximal allowed size (number of nodes) of the tree", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("FunctionTree", "The tree to mutate", typeof(IFunctionTree), VariableKind.In | VariableKind.Out));
-      AddVariableInfo(new VariableInfo("TreeSize", "The size (number of nodes) of the tree", typeof(IntData), VariableKind.In | VariableKind.Out));
-      AddVariableInfo(new VariableInfo("TreeHeight", "The height of the tree", typeof(IntData), VariableKind.In | VariableKind.Out));
     }
 
-
-    public override IOperation Apply(IScope scope) {
-      IFunctionTree root = GetVariableValue<IFunctionTree>("FunctionTree", scope, true);
-      MersenneTwister random = GetVariableValue<MersenneTwister>("Random", scope, true);
-      FunctionLibrary library = GetVariableValue<FunctionLibrary>("OperatorLibrary", scope, true);
+    internal override IOperation Manipulate(MersenneTwister random, IGeneticProgrammingModel gpModel, FunctionLibrary library, int maxTreeSize, int maxTreeHeight, IScope scope) {
       TreeGardener gardener = new TreeGardener(random, library);
-      IFunctionTree parent = gardener.GetRandomParentNode(root);
+      IFunctionTree parent = gardener.GetRandomParentNode(gpModel.FunctionTree);
 
       // parent==null means the whole tree should be deleted.
       // => return a new minimal random tree
-      if(parent == null) {
+      if (parent == null) {
         IFunctionTree newTree = gardener.CreateBalancedRandomTree(1, 1);
         // check if the tree is ok
         Debug.Assert(gardener.IsValidTree(newTree));
-        // update sizes to match the new tree
-        GetVariableValue<IntData>("TreeSize", scope, true).Data = newTree.Size;
-        GetVariableValue<IntData>("TreeHeight", scope, true).Data = newTree.Height;
-        scope.GetVariable(scope.TranslateName("FunctionTree")).Value = newTree;
-
+        gpModel.FunctionTree = newTree;
         // schedule an operation to initialize the newly created operator
-        return gardener.CreateInitializationOperation(gardener.GetAllSubTrees(newTree), scope);
+        return TreeGardener.CreateInitializationOperation(TreeGardener.GetAllSubTrees(newTree), scope);
       }
 
       // select a branch to prune
       int childIndex = random.Next(parent.SubTrees.Count);
-      if(parent.SubTrees.Count > parent.Function.MinArity) {
+      if (parent.SubTrees.Count > parent.Function.MinArity) {
         parent.RemoveSubTree(childIndex);
         // actually since the next sub-trees are shifted in the place of the removed branch
@@ -81,7 +67,8 @@
         // and find the first one that doesn't fit. At this position we insert a new randomly initialized subtree of matching type (gkronber 25.12.07)
 
-        Debug.Assert(gardener.IsValidTree(root));
-        GetVariableValue<IntData>("TreeSize", scope, true).Data = root.Size;
-        GetVariableValue<IntData>("TreeHeight", scope, true).Data = root.Height;
+        Debug.Assert(gardener.IsValidTree(gpModel.FunctionTree));
+        // recalculate size and height
+        gpModel.Size = gpModel.FunctionTree.GetSize();
+        gpModel.Height = gpModel.FunctionTree.GetHeight();
         // root hasn't changed so don't need to update 'FunctionTree' variable
         return null;
@@ -92,10 +79,10 @@
         IFunctionTree newFunctionTree = gardener.CreateRandomTree(allowedFunctions, 1, 1);
         parent.InsertSubTree(childIndex, newFunctionTree);
-        Debug.Assert(gardener.IsValidTree(root));
-        GetVariableValue<IntData>("TreeSize", scope, true).Data = root.Size;
-        GetVariableValue<IntData>("TreeHeight", scope, true).Data = root.Height;
-        // again the root hasn't changed so we don't need to update the 'FunctionTree' variable
-        // but we have to return an initialization operation for the newly created tree
-        return gardener.CreateInitializationOperation(gardener.GetAllSubTrees(newFunctionTree), scope);
+        Debug.Assert(gardener.IsValidTree(gpModel.FunctionTree));
+        // recalculate size and height
+        gpModel.Size = gpModel.FunctionTree.GetSize();
+        gpModel.Height = gpModel.FunctionTree.GetHeight();
+        // return an initialization operation for the newly created tree
+        return TreeGardener.CreateInitializationOperation(TreeGardener.GetAllSubTrees(newFunctionTree), scope);
       }
     }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/FullTreeShaker.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/FullTreeShaker.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/FullTreeShaker.cs	(revision 2210)
@@ -29,4 +29,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.Selection;
+using HeuristicLab.GP.Interfaces;
 
 namespace HeuristicLab.GP {
@@ -39,43 +40,34 @@
       : base() {
       AddVariableInfo(new VariableInfo("Random", "A random generator (uniform)", typeof(MersenneTwister), VariableKind.In));
-      AddVariableInfo(new VariableInfo("OperatorLibrary", "Operator library that defines operator mutations", typeof(FunctionLibrary), VariableKind.In));
+      AddVariableInfo(new VariableInfo("FunctionLibrary", "Function library that defines function mutations", typeof(FunctionLibrary), VariableKind.In));
       AddVariableInfo(new VariableInfo("ShakingFactor", "Variable that determines the force of the shaking operation", typeof(DoubleData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("FunctionTree", "The function tree that should be mutated", typeof(IFunctionTree), VariableKind.In | VariableKind.Out));
+      AddVariableInfo(new VariableInfo("FunctionTree", "The function tree that should be mutated", typeof(IGeneticProgrammingModel), VariableKind.In | VariableKind.Out));
     }
 
     public override IOperation Apply(IScope scope) {
-      FunctionLibrary library = GetVariableValue<FunctionLibrary>("OperatorLibrary", scope, true);
-      IFunctionTree tree = GetVariableValue<IFunctionTree>("FunctionTree", scope, false);
+      FunctionLibrary library = GetVariableValue<FunctionLibrary>("FunctionLibrary", scope, true);
+      IGeneticProgrammingModel gpModel = GetVariableValue<IGeneticProgrammingModel>("FunctionTree", scope, false);
       MersenneTwister mt = GetVariableValue<MersenneTwister>("Random", scope, true);
 
-      // enqueue all mutation operations as parallel operations
+      // save all existing sub-scopes in a backup scope
+      Scope backupScope = new Scope("backup");
+      foreach (Scope subScope in scope.SubScopes) {
+        backupScope.AddSubScope(subScope);
+      }
+
+      // create a scope for all shaking operations
+      Scope tempScope = new Scope("Temp. manipulation scope");
+      scope.AddSubScope(tempScope); // scope containing a subscope for each manipulation
+      scope.AddSubScope(backupScope); // scope containing the old subscopes
+
+      // create a composite operation for all shaking operations
       CompositeOperation next = new CompositeOperation();
       next.ExecuteInParallel = false;
 
-      Scope tempScope = new Scope("Temp. manipulation scope");
-
-      TreeGardener gardener = new TreeGardener(mt, library);
-      var parametricBranches = gardener.GetAllSubTrees(tree).Where(branch => branch.Manipulator!= null);
-      foreach(IFunctionTree subTree in parametricBranches) {
-        IOperator mutation = subTree.Manipulator;
-
-        // store all local variables into a temporary scope
-        Scope mutationScope = new Scope();
-        foreach(IVariable variable in subTree.LocalVariables) {
-          mutationScope.AddVariable(variable);
-        }
-
-        tempScope.AddSubScope(mutationScope);
-        next.AddOperation(new AtomicOperation(mutation, mutationScope));
+      // enqueue all shaking operations
+      foreach (IFunctionTree subTree in TreeGardener.GetAllSubTrees(gpModel.FunctionTree).Where(x=>x.HasLocalParameters)) {
+        IOperation shakingOperation = subTree.CreateShakingOperation(tempScope);
+        next.AddOperation(shakingOperation);
       }
-
-      // save all existing sub-scopes in a backup scope
-      Scope backupScope = new Scope("backup");
-      foreach(Scope subScope in scope.SubScopes) {
-        backupScope.AddSubScope(subScope);
-      }
-
-      scope.AddSubScope(tempScope); // scope containing a subscope for each manipulation
-      scope.AddSubScope(backupScope); // scope containing the old subscopes
 
       // schedule a reducer operation to delete all temporary scopes and restore
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/GPManipulatorBase.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/GPManipulatorBase.cs	(revision 2210)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/Manipulation/GPManipulatorBase.cs	(revision 2210)
@@ -0,0 +1,58 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Random;
+using HeuristicLab.Data;
+using HeuristicLab.Constraints;
+using System.Diagnostics;
+using HeuristicLab.Evolutionary;
+using HeuristicLab.GP.Interfaces;
+
+namespace HeuristicLab.GP {
+  public abstract class GPManipulatorBase : OperatorBase {
+    public GPManipulatorBase()
+      : base() {
+      AddVariableInfo(new VariableInfo("Random", "Uniform random number generator", typeof(MersenneTwister), VariableKind.In));
+      AddVariableInfo(new VariableInfo("FunctionLibrary", "The operator library containing all available operators", typeof(FunctionLibrary), VariableKind.In));
+      AddVariableInfo(new VariableInfo("MaxTreeHeight", "The maximal allowed height of the tree", typeof(IntData), VariableKind.In));
+      AddVariableInfo(new VariableInfo("MaxTreeSize", "The maximal allowed size (number of nodes) of the tree", typeof(IntData), VariableKind.In));
+      AddVariableInfo(new VariableInfo("FunctionTree", "The tree to crossover", typeof(IGeneticProgrammingModel), VariableKind.In | VariableKind.New));
+    }
+
+    internal abstract IOperation Manipulate(MersenneTwister random, IGeneticProgrammingModel gpModel, FunctionLibrary library, int maxSize, int maxHeight, IScope scope);
+
+    public override IOperation Apply(IScope scope) {
+      FunctionLibrary funLibrary = GetVariableValue<FunctionLibrary>("FunctionLibrary", scope, true);
+      IGeneticProgrammingModel gpModel = GetVariableValue<IGeneticProgrammingModel>("FunctionTree", scope, false);
+      MersenneTwister random = GetVariableValue<MersenneTwister>("Random", scope, true);
+      int maxTreeSize = GetVariableValue<IntData>("MaxTreeSize", scope, true).Data;
+      int maxTreeHeight = GetVariableValue<IntData>("MaxTreeHeight", scope, true).Data;
+
+      return Manipulate(random, gpModel, funLibrary, maxTreeSize, maxTreeHeight, scope);
+    }
+  }
+}
